load('result_all.mat')

%% Figure 2A (Stroop) 
n = 1;
for i = 1:16
    y{:,n} = result_all.s_c_rt{i};
    n = n+1;
    y{:,n} = result_all.s_i_rt{i};
    n = n+1;
end
face = [0.5 0.5 0.5;1 0 0];
facecolor = repmat(face,[16,1]);
xticks = [1.5:2:32.5];
xlabels = string([1:16]);
violin(y,'facecolor',facecolor,'edgecolor','k','medc',[],'plotlegend',0); 
ylim([0 2600])
ylabel('Reaction time (ms)');
set(gca,'fontsize', 10,'xtick',xticks,'xticklabel',xlabels,'TickDir','out','box','off','FontName','Arial')

%% Figure 2B (Flanker) 
n = 1;
for i = 1:16 
    y{:,n} = result_all.f_c_rt{i};
    n = n+1;
    y{:,n} = result_all.f_i_rt{i};
    n = n+1;
end
face = [0.5 0.5 0.5;1 0 0];
facecolor = repmat(face,[16,1]);
xticks = [1.5:2:32.5];
xlabels = string([1:16]);
violin(y,'facecolor',facecolor,'edgecolor','k','medc',[],'plotlegend',0); 
ylim([0 2600])
%set(gca,'YTickLabel',[]);
ylabel('Reaction time (ms)');
set(gca,'fontsize', 10,'xtick',xticks,'xticklabel',xlabels,'TickDir','out','box','off','FontName','Arial')

%% Figure 2C (Number)  
n = 1;
for i = 1:16 
    y{:,n} = result_all.n_c_rt{i};
    n = n+1;
    y{:,n} = result_all.n_i_rt{i};
    n = n+1;
end
face = [0.5 0.5 0.5;1 0 0];
facecolor = repmat(face,[16,1]);
xticks = [1.5:2:32.5];
xlabels = string([1:16]);
violin(y,'facecolor',facecolor,'edgecolor','k','medc',[],'plotlegend',0); 
ylim([0 2600])
ylabel('Reaction time (ms)');
set(gca,'fontsize', 10,'xtick',xticks,'xticklabel',xlabels,'TickDir','out','box','off','FontName','Arial')

%% Figure 2D 
sem_diff_stroop = std(result_all.diff_stroop)/sqrt(length(result_all.diff_stroop)); 
sem_diff_flanker = std(result_all.diff_flanker)/sqrt(length(result_all.diff_flanker)); 
sem_diff_number = std(result_all.diff_number)/sqrt(length(result_all.diff_number)); 
y = [mean(result_all.diff_stroop);mean(result_all.diff_flanker);mean(result_all.diff_number)]; 
ngroups = size(y, 1);
err = [sem_diff_stroop;sem_diff_flanker;sem_diff_number]; 
nbars = size(y, 2);
bar(y)

hold on; 
ylabel('RT(incon) / RT(con)');
groupwidth = min(0.8, nbars/(nbars + 1.5));
for i = 1:nbars
    x = (1:ngroups) - groupwidth/2 + (2*i-1) * groupwidth / (2*nbars);
    e = errorbar(x, y(:,i), err(:,i), '.');
    e.Color = 'black'; 
    e.CapSize = 10; 
    hold on; 
end
line([0.5 3.5],[1 1],'color','k','linestyle','--','linewidth',1.5);
set(gca,'xtick',[1 2 3],'xticklabel',{'Stroop','Flanker','Number'},'fontsize', 10,'FontName','Arial','box','off','TickDir','out')