%% Instruction
% 1. Replace subject number for running this code for other subjects. For
% example, find and replace "subn" with "subn+1". 
% 2. "Electrode info" for all patients can be found in "info_channel.m".
% Replace this section with contents in "info_channel.m" for other
% patients. 


%% Initialize functions
addpath_recurse('chronux_2_12');
addpath_recurse('functions_general');

%%
load(fullfile('data_recording','sub6','nf_sub6.mat')); % sub6stitue for other sub6jects
raw_voltage = nf_sub6; 

%% Electrode info (see instruction for other patients) 
bad_channel = [4:8 11:13 15 16 22 26 28:31 36 37 40:44 46 49:46 48:52 55:58 61:70 72];
total_channel = 72;
good_channel = sort(setdiff(1:total_channel,bad_channel)); 
sr = 512;
%%
load(fullfile('data_recording','sub6','trigger_info.mat'));
load(fullfile('data_recording','sub6','result_gamma','sub6_art_flanker.mat'));
load(fullfile('data_recording','sub6','result_gamma','A02_gamma_flanker_sub6.mat'));
load(fullfile('data_psychophysics','sub6','congruency_flanker'));
load(fullfile('data_psychophysics','sub6','rt_flanker'));
load(fullfile('data_psychophysics','sub6','correct_flanker'));
load('t_trial.mat'); 

%% Analyze response aligned 
before_voice = sr*2.5;
after_voice = sr*2.5;
filter_space = sr; 
filter_space_after = sr*2;
normRange = sr/2; 

for i_channel = [117 92]%good_channel
    art = sub6_art_flanker{i_channel}; 
    %raw_voltage(i_channel,:) = ft_preproc_lowpassfilter(raw_voltage(i_channel,:),sr,300, 4, 'but');
    current = 1;
    correct_ind = 1; 
    for i = 1:height(trigger_info)
        if strcmp(trigger_info.task{i},'flanker') && strcmp(trigger_info.message{i},'stim_on')
            
            if  correct_flanker(correct_ind)==1 && ~ismember(correct_ind,art) 
                rt =round(rt_flanker(correct_ind)/1000*sr);
                rt_sec(current) = rt_flanker(correct_ind)/1000; 
%                 start = trigger_info.timestamp(i-1)-filter_space; 
%                 ending = trigger_info.timestamp(i+1)+filter_space_after; 
%                 trials_response{current} = raw_voltage(i_channel,start:ending); 
%                 
%                 
%                 
%                 base_start = trigger_info.timestamp(i-1)-filter_space; 
%                 base_end = trigger_info.timestamp(i-1)+normRange+filter_space; 
%                 base{current} = raw_voltage(i_channel,base_start:base_end); 
%                 
%                 trial_start  = trigger_info.timestamp(i)-filter_space;
%                 trial_end = trigger_info.timestamp(i+1)+filter_space;
                
                congruency(current) = congruency_flanker(correct_ind); 
                                
                
                current = current+1; 
                correct_ind = correct_ind+1; 
            else
                correct_ind = correct_ind+1; 
            end
        end
    end
    t_decode = t_trial(93:end);
    t_decode = t_decode-(t_decode(1)-(0)); % make the t_decode(1) = 0
%     for i = 1:length(trials_response) 
%         this_trial =  trials_response{i};
%         params.fpass = [70 120];params.err = [1 0.01];
%         params.movingwin = [0.2 0.01];
%         params.tapers = [5 7];
%         this_trial = computeNormalizedFreqMag(this_trial',sr,params);
%         mean_rt = nanmean(rt_flanker)/1000; 
%         [~,final_ind] = min(abs(t_trial-(mean_rt+2)));
%         this_trial = this_trial(93:final_ind); 
%         this_base = computeNormalizedFreqMag(base{i}',sr,params);
%         this_base = this_base(93:144); 
%         mean_base = mean(this_base); 
%         this_trial = this_trial-mean_base; 
%         this_trial = this_trial./std(this_base);
%         trials_matrix(i,:) = this_trial; 
%         
%         this_trial_rt = rt_sec(i);
%         [~,trial_end_ind] = min(abs(t_trial-(this_trial_rt+1.5)));
%         if trial_end_ind>length(this_trial)
%             trial_end_ind = length(this_trial);
%         end
%         this_trial_only = this_trial(145:trial_end_ind);
%         [trial_max(i),max_idx(i)] = max(this_trial_only);
%         trial_mean(i) = mean(this_trial_only);
%         trial_area(i) = sum(abs(this_trial_only));
%     end
    
   % A02_gamma_flanker_sub6{i_channel} = trials_matrix; 
    trials_matrix = A02_gamma_flanker_sub6{i_channel};
    
    con_ind = find(congruency==1); 
    incon_ind = find(congruency==-1);  
%     conf_maxPower_flanker_con_02_sub6{i_channel} = trial_max(con_ind);  
%     conf_maxPower_flanker_in_02_sub6{i_channel} = trial_max(incon_ind); 
%     conf_meanPower_flanker_con_02_sub6{i_channel} = trial_mean(con_ind);  
%     conf_meanPower_flanker_in_02_sub6{i_channel} = trial_mean(incon_ind); 

% RT equalization
    percent_taken = 0.9; 
    n_taken = floor(min(length(con_ind),length(incon_ind))*percent_taken);    
    con_rt = rt_sec(con_ind); incon_rt = rt_sec(incon_ind); 
    mean_all = mean(rt_sec); 
    diff_val_con = abs(con_rt - mean_all);
    diff_val_in = abs(incon_rt - mean_all);
    [~, indx_con] = sort(diff_val_con);
    [~, indx_in] = sort(diff_val_in);
    indx_con = indx_con(1:n_taken);
    indx_in = indx_in(1:n_taken);
    con_ind = sort(con_ind(indx_con));
    incon_ind = sort(incon_ind(indx_in));

    rt_con_new = con_rt(indx_con);
    rt_in_new = incon_rt(indx_in); 
    

    p_RT = permutationTest(rt_con_new, rt_in_new,10000);

    if p_RT < 0.05
        error('RT not equalized')
    end


    con_matrix = trials_matrix(con_ind,:); 
    incon_matrix = trials_matrix(incon_ind,:); 
    t_now = t_trial(93:end);
    t_now = t_now-(t_now(1)-(-0.5)); % make the t_now(1) = -0.5, now response_time = 0; 

    mean_rt = 1000*mean([rt_con_new,rt_in_new]); % in msec 
    [~,plot_start] = min(abs(t_now-(-0.5))); 
    [~,plot_end] = min(abs(mean_rt/1000+0.5-t_now));  
    if plot_end>size(con_matrix,2)
        plot_end = size(con_matrix,2)
    end
    t_plot = t_now(plot_start:plot_end); 
    con_matrix = con_matrix(:,plot_start:plot_end); 
    incon_matrix = incon_matrix(:,plot_start:plot_end); 

    %% permutation Test  
    
    [~,compare_start] = min(abs(t_plot-0));
    [~,compare_end] = min(abs(t_plot-mean_rt/1000));
    mean_congruent = mean(con_matrix);
    mean_incongruent = mean(incon_matrix); 
    p = [];
    for i = compare_start:compare_end
        p(i) = permutationTest((con_matrix(:,i)),(incon_matrix(:,i)),5000); 
    end
    p(1:compare_start-1) = NaN;
    p(compare_end+1:end) = NaN; 
    h = p;
    for i = 1:length(h)
        if h(i)<=0.05
            h(i)=1;
        else
            h(i)=0;
        end
    end
    sum15 = [];
    for i = 1:(length(h)-14)
        sum15(i) = sum(h(i:i+14));
    end
    start2 = strfind([0,sum15==15],[0 1]);
    end2 = strfind([sum15==15,0],[1 0]); end2 = end2+14;
    if ismember(15,sum15)
        A02_ifflanker_gamma_sub6(i_channel) = 1; 
    else
        A02_ifflanker_gamma_sub6(i_channel) = 0; 
    end   
    
    if max(mean_congruent(compare_start:compare_start+29))>=2&& max(mean_incongruent(compare_start:compare_start+29))>=2
        A02_visual_flanker_sub6(i_channel)=1; 
    else
        A02_visual_flanker_sub6(i_channel)=0;
    end

    sem_congruent = std(con_matrix)/sqrt(size(con_matrix,1)); 
    sem_incongruent = std(incon_matrix)/sqrt(size(incon_matrix,1)); 
    
%%     % Plot 
        figure(i_channel)
        t = t_plot;
        ylimit = [-0.7 4];
        if A02_ifflanker_gamma_sub6(i_channel)==1
            for i = 1:length(start2)
                a1 = t(start2(i));
                a2 = t(end2(i));
                rectangle('Position',[a1,ylimit(1)+0.05,a2-a1,ylimit(2)-ylimit(1)],'EdgeColor',[1 0.949 0.8],'FaceColor',[1 0.949 0.8])
                hold on; 
            end
        end
        hold on; 
        s1 = shadedErrorBar(t,mean_congruent,sem_congruent,'lineprops',{'-k'});
        set(s1.edge,'LineWidth',0.01)
        s1.mainLine.LineWidth = 2;
        hold on;
        s2 = shadedErrorBar(t,mean_incongruent,sem_incongruent,'lineprops',{'-r'});  
        set(s2.edge,'LineWidth',0.01)
        s2.mainLine.LineWidth = 2;
        xlabel('Time from stimulus (s)');
        %ylabel('Gamma power (z-scored)'); 
        xlim([t(1) t(end)]);
        ylim(ylimit); 
        titleName = sprintf('flanker stim aligned');
        %title(titleName);  
        names = string([-0.4:0.4:2]);
        set(gca,'fontsize', 10,'xtick',[-0.4:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial')
        set(gca,'YTickLabel',[]);
        line([mean_rt/1000,mean_rt/1000],ylimit,'color','k','linestyle','--')
        legend1 = sprintf('n=%d',length(con_ind));
        legend2 = sprintf('n=%d',length(incon_ind));
        legend([s1.mainLine,s2.mainLine],{legend1,legend2},'FontSize',9,'Location','northwest','FontName','Arial');
        saveName = sprintf('flanker_stim_aligned_sub6_channel%d',i_channel);
%         saveas(figure(i_channel),saveName,'epsc')
%         close(figure(i_channel))
   
      
 
    %%
    clear con_matrix congruency incon_matrix trials_matrix trials_response base p sum5 type1_matrix ...
          type2_matrix type3_matrix type4_matrix type5_matrix type6_matrix type7_matrix type8_matrix type9_matrix trials_stimAlign 
 end
% save('A02_ifflanker_gamma_sub6.mat','A02_ifflanker_gamma_sub6');
% save('A02_gamma_flanker_sub6.mat','A02_gamma_flanker_sub6');
% save('A02_visual_flanker_sub6.mat','A02_visual_flanker_sub6');

