%% Instruction
% 1. Replace subject number for running this code for other subjects. For
% example, find and replace "subn" with "subn+1". 
% 2. "Electrode info" for all patients can be found in "info_channel.m".
% Replace this section with contents in "info_channel.m" for other
% patients. 

%% Initialize functions
addpath_recurse('chronux_2_12');
addpath_recurse('functions_general');

%%
load(fullfile('data_recording','sub16','nf_sub16.mat')); % substitue for other subjects
raw_voltage = nf_sub16; 

%% Electrode info (see instruction for other patients) 
bad_channel = [1:7,9:17 19:23 25 28 33 35 36 39,46:55 59:65,67:76,79 80 83:87 89 91 94:96 99 102:106 109:113];
total_channel = 118; 
good_channel = sort(setdiff(1:total_channel,bad_channel)); 
sr = 2048; 
%%
load(fullfile('data_recording','sub16','trigger_info.mat'));
load(fullfile('data_recording','sub16','result_gamma','sub16_art_number.mat'));
load(fullfile('data_recording','sub16','result_gamma','A02_gamma_number_sub16.mat'));
load(fullfile('data_psychophysics','sub16','congruency_number'));
load(fullfile('data_psychophysics','sub16','vrt_number'));
load(fullfile('data_psychophysics','sub16','correct_number'));
load('t_trial.mat'); 



%% Analyze response aligned 
% before_voice = sr*2.5;
% after_voice = sr*2.5;
% filter_space = sr; 
% filter_space_after = sr*2;
% normRange = sr/2; 

% sub16_gammaMax_number_in = cell(max(good_channel),1);
% sub16_gammaMax_number_con = cell(max(good_channel),1);
% sub16_gammaMean_number_con =cell(max(good_channel),1);
% sub16_gammaMean_number_in = cell(1,max(good_channel));

%
for i_channel = 30%good_channel % change this to good_channel if you want to run the code for all the channels
    art = sub16_art_number{i_channel}; 
    %raw_voltage(i_channel,:) = ft_preproc_lowpassfilter(raw_voltage(i_channel,:),sr,300, 4, 'but');
    current = 1;
    correct_ind = 1; 
    for i = 1:height(trigger_info)
        if strcmp(trigger_info.task{i},'number') && strcmp(trigger_info.message{i},'stim_on')
            
            if  correct_number(correct_ind)==1 && ~ismember(correct_ind,art) 
                vrt =round(vrt_number(correct_ind)/1000*sr);
                vrt_sec(current) = vrt_number(correct_ind)/1000; 
%                 start = trigger_info.timestamp(i-1)-filter_space; 
%                 ending = trigger_info.timestamp(i+1)+filter_space; 
%                 trials_response{current} = raw_voltage(i_channel,start:ending); 
%                 
%                 
%                 
%                 base_start = trigger_info.timestamp(i-1)-filter_space; 
%                 base_end = trigger_info.timestamp(i-1)+normRange+filter_space; 
%                 base{current} = raw_voltage(i_channel,base_start:base_end); 
%                 
%                 trial_start  = trigger_info.timestamp(i)-filter_space;
%                 trial_end = trigger_info.timestamp(i+1)+filter_space;
%                 trials_stimAlign{current} = raw_voltage(i_channel,trial_start:trial_end);
                
                congruency(current) = congruency_number(correct_ind); 
                                
                
                current = current+1; 
                correct_ind = correct_ind+1; 
            else
                correct_ind = correct_ind+1; 
            end
        end
    end
    trials_matrix = A02_gamma_number_sub16{i_channel};

    con_ind = find(congruency==1); 
    incon_ind = find(congruency==-1);
    con_matrix = trials_matrix(con_ind,:); con_vrt = vrt_sec(con_ind); 
    incon_matrix = trials_matrix(incon_ind,:); incon_vrt = vrt_sec(incon_ind); 
    t_now = t_trial(93:end);
    t_now = t_now-(t_now(1)-(-0.5));  
    mean_vrt = nanmean(vrt_number); % in msec 
    [~,plot_start] = min(abs(t_now-(-0.5))); 
    [~,plot_end] = min(abs(t_now-2));  
    t_plot = t_now(plot_start:plot_end);
    con_matrix = con_matrix(:,plot_start:plot_end);
    incon_matrix = incon_matrix(:,plot_start:plot_end);

    [~,compare_start] = min(abs(t_plot-0)); 
    [~,compare_end] = min(abs(t_plot-2));   %in t_now
    %
    con_matrix_1 = con_matrix(:,compare_start:compare_end);
    incon_matrix_1 = incon_matrix(:,compare_start:compare_end);
    t_1 = t_plot(compare_start:compare_end); 
    vrt_con = vrt_sec(con_ind); 
    vrt_in = vrt_sec(incon_ind); 
    [max_con,I_con] = max(con_matrix_1,[],2);
    [max_in,I_in] = max(incon_matrix_1,[],2);
    mean_con = mean(con_matrix_1,2);
    mean_in = mean(incon_matrix_1,2); 
    
    % 
%     fit_con=fitlm(vrt_con,t_1(I_con)); p_con = fit_con.Coefficients.pValue(2);
%     fit_in = fitlm(vrt_in,t_1(I_in)); p_in = fit_in.Coefficients.pValue(2);
%     if p_con<=0.05
%         rtCorr_number_sub16(i_channel,1) = 1;
%     else
%         rtCorr_number_sub16(i_channel,1) = 0;
%     end
%     if p_in<=0.05
%         rtCorr_number_sub16(i_channel,2) = 1;
%     else
%         rtCorr_number_sub16(i_channel,2) = 0;
%     end   
%     %%
%     fit_con=fitlm(vrt_con,max_con); p_con = fit_con.Coefficients.pValue(2);
%     fit_in = fitlm(vrt_in,max_in); p_in = fit_in.Coefficients.pValue(2);
%     if p_con<=0.05
%         rtCorr_number_sub16(i_channel,3) = 1;
%     else
%         rtCorr_number_sub16(i_channel,3) = 0;
%     end
%     if p_in<=0.05
%         rtCorr_number_sub16(i_channel,4) = 1;
%     else
%         rtCorr_number_sub16(i_channel,4) = 0;
%     end
    
    %%
    fit_con=fitlm(vrt_con,mean_con); p_con = fit_con.Coefficients.pValue(2);
    fit_in = fitlm(vrt_in,mean_in); p_in = fit_in.Coefficients.pValue(2);
    if p_con<=0.05
        rtCorr_number_sub16(i_channel,5) = 1;
    else
        rtCorr_number_sub16(i_channel,5) = 0;
    end
    if p_in<=0.05
        rtCorr_number_sub16(i_channel,6) = 1;
    else
        rtCorr_number_sub16(i_channel,6) = 0;
    end


        
        %% Plot mean con 
        figure(1)
        scatter(vrt_con,mean_con,4,'filled','k')
        P = polyfit(vrt_con',mean_con,1);
        yfit = P(1)*vrt_con+P(2);
        hold on;
        plot(vrt_con,yfit,'k-');
        ylim([-5 15])
        xlabel('Reaction time (s)');
        ylabel('Mean \gamma power');  
        legend_text = sprintf('number (c), n=%d',length(vrt_con));
        legend(sprintf('p=%.3f',p_con));
        names = string([-0.4:0.4:2]);
        set(gca,'fontsize', 8,'xtick',[-0.4:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')

        
        %% Plot mean in
        figure(2)
        scatter(vrt_in,mean_in,4,'filled','k')
        P = polyfit(vrt_in',mean_in,1);
        yfit = P(1)*vrt_in+P(2);
        hold on;
        plot(vrt_in,yfit,'k-');
        ylim([-5 15])
        xlabel('Reaction time (s)');
        ylabel('Mean \gamma power (z-scored)');  
        legend_text = sprintf('number (i), n=%d',length(vrt_in));
        legend(sprintf('p=%.3f',p_in));
        names = string([-0.4:0.4:2]);
        set(gca,'fontsize', 8,'xtick',[-0.4:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')

% %   
%%      
%  
%     
  %     clear con_matrix congruency incon_matrix trials_matrix trials_response base p sum15 type1_matrix ...
   %      type2_matrix type3_matrix start2 end2 type5_matrix type6_matrix type7_matrix type8_matrix type9_matrix trials_stimAlign 
end

% save('rtCorr_number_sub16.mat','rtCorr_number_sub16'); 

