%% Instruction
% 1. Replace subject number for running this code for other subjects. For
% example, find and replace "subn" with "subn+1". 
% 2. "Electrode info" for all patients can be found in "info_channel.m".
% Replace this section with contents in "info_channel.m" for other
% patients.

%% Initialize functions
addpath_recurse('chronux_2_12');
addpath_recurse('functions_general');

%%
load(fullfile('data_recording','sub16','nf_sub16.mat')); % substitue for other subjects
raw_voltage = nf_sub16; 

% load electrode info from in_channel.m 

%%
bad_channel = [1:7,9:17 19:23 25 28 33 35 36 39,46:55 59:65,67:76,79 80 83:87 89 91 94:96 99 102:106 109:113];
total_channel = 118; 
good_channel = sort(setdiff(1:total_channel,bad_channel)); 
sr = 2048; 
%%
load(fullfile('data_recording','sub16','trigger_info.mat'));
load(fullfile('data_recording','sub16','result_gamma','sub16_art_flanker.mat'));
load(fullfile('data_recording','sub16','result_low','A01_low_flanker_sub16.mat'));
load(fullfile('data_psychophysics','sub16','congruency_flanker'));
load(fullfile('data_psychophysics','sub16','rt_flanker'));
load(fullfile('data_psychophysics','sub16','correct_flanker'));
load('t_trial.mat'); 

%% Analyze response aligned signal
before_voice = sr*2.5;
after_voice = sr*2.5; % give room for different subjects'performance, need to trim to same length in the end 
filter_space = sr; 
normRange = sr/2; 

% % Find Artifact 
% for i_channel = good_channel
%     amps = [];
%     current = 1; 
%     for i = 1:height(trigger_info)
%         if strcmp(trigger_info.task{i},'flanker') && strcmp(trigger_info.message{i},'stim_on')
%             start = trigger_info.timestamp(i-1); 
%             ending = trigger_info.timestamp(i+1); 
%             tent1 = raw_voltage(i_channel,start:ending); 
%             amps = [amps;max(tent1)-min(tent1)];
%             current = current+1;
%         end
%     end
% 
%     mean_amp = mean(amps);
%     std_amp = std(amps);
%     sub16_art_flanker{i_channel} = find(amps>mean_amp+3*std_amp);
% 
% end

for i_channel = 116%good_channel % change this to good_channel if you want to run the code for all the channels
    art = sub16_art_flanker{i_channel}; 
    current = 1;
    correct_ind = 1; 
    for i = 1:height(trigger_info)
        if strcmp(trigger_info.task{i},'flanker') && strcmp(trigger_info.message{i},'stim_on')
            
            if  correct_flanker(correct_ind)==1 && ~ismember(correct_ind,art) 
                rt =round(rt_flanker(correct_ind)/1000*sr); 
                rt_sec(current) = rt_flanker(correct_ind)/1000;
                start = trigger_info.timestamp(i)+rt-before_voice-filter_space; 
                ending = trigger_info.timestamp(i)+rt+after_voice+filter_space; %3.5 s left to rt, 3.5 s right to rt 
                %trials_response_rAlign{current} = raw_voltage(i_channel,start:ending);               
                
                base_start = trigger_info.timestamp(i-1)-filter_space; 
                base_end = trigger_info.timestamp(i)+filter_space;
                %base{current} = raw_voltage(i_channel,base_start:base_end);                              
                
                congruency(current) = congruency_flanker(correct_ind); 
                if correct_ind <=30 
                    n_block(current) = 1;
                elseif correct_ind >30 && correct_ind <=60
                    n_block(current) = 2;
                elseif correct_ind >60 && correct_ind <=90
                    n_block(current) = 3;
                elseif correct_ind >90 && correct_ind <=120
                    n_block(current)= 4;
                elseif correct_ind >120 && correct_ind <=150
                    n_block(current) = 5;
                elseif correct_ind >150 && correct_ind <=180
                    n_block(current) = 6;
                elseif correct_ind >180 && correct_ind <=210
                    n_block(current) = 7;
                end
                
                current = current+1; 
                correct_ind = correct_ind+1; 
            else
                correct_ind = correct_ind+1; 
            end
        end
    end

%     for i = 1:length(trials_response_rAlign) 
%         this_trial = trials_response_rAlign{i}; 
%         params.fpass = [35 70]; params.err = [1 0.01]; % theoretical error bar 
%         [this_trial,S_trial,f] = computeNormalizedFreqMag(this_trial',sr,params);
%         this_trial = this_trial(93:605); % now 2.5 s left to rt, 2.5 s right to rt, allow room on the right side for different subject performance, need to trim anyway
%         [this_base,S_base] = computeNormalizedFreqMag(base{i}',sr,params);
%         this_base = this_base(93:144); % 500ms before stim onset  
%         this_trial = this_trial-mean(this_base); 
%         this_trial = this_trial./std(this_base); 
%         trials_matrix(i,:) = this_trial; 
%     end
    
    %A01_low_flanker_sub16{i_channel} = trials_matrix; % next time you can use saved results for faster running
    trials_matrix = A01_low_flanker_sub16{i_channel}; 
    
    con_ind = find(congruency==1); n_con_ind = length(con_ind);
    incon_ind = find(congruency==-1); n_incon_ind = length(incon_ind);
    con_ind_block = n_block(con_ind);
    incon_ind_block = n_block(incon_ind);

    con_matrix = trials_matrix(con_ind,:); 
    incon_matrix = trials_matrix(incon_ind,:); incon_rt = rt_sec(incon_ind); 
    t_now = t_trial(93:end);
    t_now = t_now-(t_now(1)-(-2.5)); % make the t_now(1) = -2.5, now response_time = 0; 
    t_now = t_now(1:size(con_matrix,2));
    
    mean_rt = nanmean(rt_flanker); 
    fix_onset = -mean_rt/1000-0.5; %500 ms before average stimulus onset 
    [~,plot_start] = min(abs(t_now-fix_onset)); 
    [~,plot_end] = min(abs(t_now-0));
    t_plot = t_now(plot_start:plot_end); 
    
    con_matrix = con_matrix(:,plot_start:plot_end); 
    incon_matrix = incon_matrix(:,plot_start:plot_end); 
   
    mean_congruent = mean(con_matrix);   
    mean_incongruent = mean(incon_matrix); 
    
    ave_onset = -mean_rt/1000;
    [~,compare_start] = min(abs(t_plot-ave_onset)); 
    [~,compare_end] = min(abs(t_plot-0)); 
    
    p = [];
    for i = compare_start:compare_end
        p(i) = permutationTest((con_matrix(:,i)),(incon_matrix(:,i)),5000); 
    end
    p(1:compare_start-1) = NaN;
    p(compare_end+1:end) = NaN; 
    h = p;
    for i = 1:length(h)
        if h(i)<=0.05
            h(i)=1;
        else
            h(i)=0;
        end
    end
    sum15 = [];
    for i = 1:(length(h)-14)
        sum15(i) = sum(h(i:i+14));
    end
    start2 = strfind([0,sum15==15],[0 1]);
    end2 = strfind([sum15==15,0],[1 0]); end2 = end2+14;
    if ismember(15,sum15)
        A01_ifFlanker_low_sub16(i_channel) = 1; 
    else
        A01_ifFlanker_low_sub16(i_channel) = 0; 
    end   

    %% Calculate features for decoding analyses
    % MaxPower, MaxPower timing, meanPower, 
    con_matrix_1 = con_matrix(:,compare_start:compare_end); 
    incon_matrix_1 = incon_matrix(:,compare_start:compare_end);    
    [max_con,max_con_idx] = max(con_matrix_1,[],2);  
    [max_incon,max_incon_idx] = max(incon_matrix_1,[],2);
    t_max = t_now(compare_start:compare_end);
    sub16_lowMax_flanker_con{i_channel} = max_con; 
    sub16_lowMax_flanker_in{i_channel} = max_incon; 
    sub16_lowMean_flanker_con{i_channel} = mean(con_matrix_1,2); 
    sub16_lowMean_flanker_in{i_channel} = mean(incon_matrix_1,2); 
  

    sem_congruent = std(con_matrix)/sqrt(size(con_matrix,1)); 
    sem_incongruent = std(incon_matrix)/sqrt(size(incon_matrix,1)); 
    
%     %% Randomize label and test again 
%     n_total = n_con_ind+n_incon_ind;
%     for i_iter = 1
%         rand_ind = randperm(n_total); 
%         S_all = [con_matrix;incon_matrix];
%         S_all = S_all(rand_ind,:); 
%         S1_rand = S_all(1:n_con_ind,:);
%         S2_rand = S_all(n_con_ind+1:end,:);
%         p_value_rand = [];
%         for i = compare_start:compare_end
%             p_value_rand(i) = permutationTest(S1_rand(:,i),S2_rand(:,i),5000);
%         end
%         p_value_rand(1:compare_start-1) = NaN;
%         p_value_rand(compare_end+1:end) = NaN; 
%         h = p_value_rand;
%         for i = 1:length(h)
%             if h(i)<=0.05
%                 h(i)=1;
%             else
%                 h(i)=0;
%             end
%         end
%         sum15 = [];
%         for i = 1:(length(h)-14)
%             sum15(i) = sum(h(i:i+14));
%         end
%         if ismember(15,sum15)
%             A01_ifFlanker_low_sub16_rand(i_channel,i_iter) = 1; 
%         else
%             A01_ifFlanker_low_sub16_rand(i_channel,i_iter) = 0; 
%         end
%     end
    
    %% Line plot  
    figure(1)
    ylimit = [-0.7 4];
    if A01_ifFlanker_low_sub16(i_channel)==1
        for i = 1:length(start2)
            a1 = t_plot(start2(i));
            a2 = t_plot(end2(i));
            rectangle('Position',[a1,ylimit(1)+0.05,a2-a1,ylimit(2)-ylimit(1)],'EdgeColor',[1 0.949 0.8 0.7],'FaceColor',[1 0.949 0.8 0.7])
            hold on; 
        end
    end
    hold on; 
    s1 = shadedErrorBar(t_plot,mean_congruent,sem_congruent,'lineprops',{'-k'});
    set(s1.edge,'LineWidth',0.01)
    s1.mainLine.LineWidth = 2;
    hold on;
    s2 = shadedErrorBar(t_plot,mean_incongruent,sem_incongruent,'lineprops',{'-r'});  
    set(s2.edge,'LineWidth',0.01)
    s2.mainLine.LineWidth = 2;
    xlim([t_plot(1) 0])
    
    ylim(ylimit);
    xlabel('Time to response (s)');
    ylabel('Low \gamma power (z-scored)');  
    titleName = sprintf('Flanker');
    %title(titleName);  
    names = string([-2:0.4:2]);
    set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial')
    %set(gca,'YTickLabel',[]);
    line([0-mean_rt/1000,0-mean_rt/1000],ylimit,'color','k','linestyle','--')
    legend1 = sprintf('n=%d',length(con_ind));
    legend2 = sprintf('n=%d',length(incon_ind));
    legend([s1.mainLine,s2.mainLine],{legend1,legend2},'FontSize',9,'Location','northwest','FontName','Arial');
    saveName = sprintf('flanker_response_aligned_sub16_channel%d',i_channel);
%     saveas(figure(i_channel),saveName,'jpeg')
%     close(figure(i_channel));

%     %% Raster plot - congruent
%     figure(i_channel)
%     clear xticks
%     xpoints =-fliplr(0:0.4:(-t_plot(1)));
%     for i = 1:length(xpoints)
%         [~,xticks(i)] = min(abs(t_plot-xpoints(i))); 
%     end
%     rt_con = mean(rt_sec(find(congruency==1)));
%     rt_in = mean(rt_sec(find(congruency==-1)));
%     [~,rt_con_tick] = min(abs(t_plot-(-rt_con)));  
%     [~,rt_in_tick] = min(abs(t_plot-(-rt_in)));  
%     con_matrix_r = con_matrix(:,plot_start:plot_end);
%     incon_matrix_r = incon_matrix(:,plot_start:plot_end);
%     
%     image(con_matrix_r,'CDataMapping','scaled') 
%     
%     %cb = colorbar;
%     caxis([0 5])    
%     titleName = sprintf('Congruent');
%     title(titleName); 
%     names = string(xpoints);
%     yticks_con = [find(diff(con_ind_block)==1),length(con_ind)];
%     yticks_con_names = string(1:length(yticks_con));
%     
%     hold on;
%     line([rt_con_tick,rt_con_tick],[n_con_ind 1],'Color','w','LineWidth',1)
%     hold on; 
%     
%     rec_x = -1;
%     rec_y = find(diff(con_ind_block)==1);
%     rec_y = [0,rec_y+1];
%     for i = 1:length(rec_y)
%         if mod(i,2) == 1 
%             faceColor = [0.85 0.85 0.85];
%         else
%             faceColor = [1 1 1];
%         end
%         if i == 1
%             rectangle('Position',[rec_x rec_y(i) 4 length(find(con_ind_block==i))+1],'FaceColor',faceColor)
%         else
%             rectangle('Position',[rec_x rec_y(i) 4 length(find(con_ind_block==i))],'FaceColor',faceColor)
%         end
%     end
%         
%     xlabel('Time to response (s)');
%     %ylabel('Block')
%     hold on;
%     set(gca,'YTickLabel',[]);
%     set(gca,'Ytick',[]);
%     %ylabel(cb,'\low power (z-scored)'); 
%     set(gca,'fontsize', 10,'xtick',xticks,'xticklabel',names,'TickDir','out','Box','off','FontName','Arial')
%     print -painters -depsc 2.eps
%  
%     %% Raster plot - incongruent
%     figure(i_channel)
%     image(incon_matrix_r,'CDataMapping','scaled') 
%     %cb = colorbar; 
%     caxis([0 5])
%     titleName = sprintf('Incongruent');
%     title(titleName); 
%     yticks_in = [find(diff(incon_ind_block)==1),length(incon_ind)];
%     yticks_in_names = string(1:length(yticks_in));
%     
%     hold on;
%     line([rt_in_tick,rt_in_tick],[n_incon_ind 1],'Color','w','LineWidth',1)
%     rec_y = find(diff(incon_ind_block)==1);
%     rec_y = [0,rec_y+1];
%     for i = 1:length(rec_y)
%         if mod(i,2) == 1 
%             faceColor = [0.85 0.85 0.85];
%         else
%             faceColor = [1 1 1];
%         end
%         if i == 1
%         rectangle('Position',[rec_x rec_y(i) 4 length(find(incon_ind_block==i))+1],'FaceColor',faceColor)
%         else
%         rectangle('Position',[rec_x rec_y(i) 4 length(find(incon_ind_block==i))],'FaceColor',faceColor)
%         end
%     end
%     xlabel('Time to response (s)');
%     %ylabel('Block')
%     hold on;
%         set(gca,'YTickLabel',[]);
%     set(gca,'Ytick',[]);
%     %ylabel(cb,'\low power (z-scored)'); 
%     set(gca,'fontsize', 10,'xtick',xticks,'xticklabel',names,'TickDir','out','Box','off','FontName','Arial')

    %%   
       %clear con_matrix congruency incon_matrix trials_matrix trials_response_rAlign base p h trials_stimAlign Ai Ac start2 end2 start2 end2 h s1 s2 params names con_matrix_2 incon_matrix_2 con_matrix_1 incon_matrix_1...
       %   binAve_con binAve_in binMean_con binMean_in sum15 S_matrix S_con_matrix S_in_matrix sum15_null matrix_mixed xticks sum_mean
end
% 
%save('A01_ifFlanker_low_sub16.mat','A01_ifFlanker_low_sub16');
%save('sub16_lowMax_flanker_con.mat','sub16_lowMax_flanker_con'); 
% save('sub16_lowMax_flanker_in.mat','sub16_lowMax_flanker_in'); 
% save('sub16_lowMean_flanker_con.mat','sub16_lowMean_flanker_con');
% save('sub16_lowMean_flanker_in.mat','sub16_lowMean_flanker_in');
%save('A01_low_flanker_sub16.mat','A01_low_flanker_sub16');
% save('sub16_art_flanker.mat','sub16_art_flanker'); 




