load('withinData_stroop_theta.mat');
load('withinData_flanker_theta.mat');
load('withinData_number_theta.mat');

p_stroop_1 = permutationTest(accuracy_stroop_1,repmat(50,[1 50]),10000);
p_stroop_2 = permutationTest(accuracy_stroop_2,repmat(50,[1 50]),10000);
p_flanker_1 = permutationTest(accuracy_flanker_1,repmat(50,[1 50]),10000);
p_flanker_2 = permutationTest(accuracy_flanker_2,repmat(50,[1 50]),10000);
p_number_1 = permutationTest(accuracy_number_1,repmat(50,[1 50]),10000);
p_number_2 = permutationTest(accuracy_number_2,repmat(50,[1 50]),10000);

%% Calculate
y = [mean(accuracy_stroop_1),mean(accuracy_stroop_2),mean(accuracy_stroop_3),...
    mean(accuracy_flanker_1),mean(accuracy_flanker_2),mean(accuracy_number_1),mean(accuracy_number_2),...
    mean(accuracy_number_3)];
errbars = [std(accuracy_stroop_1)/sqrt(50),std(accuracy_stroop_2)/sqrt(50),std(accuracy_stroop_3)/sqrt(50),...
    std(accuracy_flanker_1)/sqrt(50),std(accuracy_flanker_2)/sqrt(50),...
    std(accuracy_number_1)/sqrt(50),std(accuracy_number_2)/sqrt(50),std(accuracy_number_3)/sqrt(50)]; 

%% Plot 
x = [1 2 3 5 6 8 9 10];
bar(x,y,'FaceColor',[0.5 .5 .5],'EdgeColor',[0 0 0],'LineWidth',1.5); 
hold on; 
er = errorbar(x,y,errbars,errbars);    
er.Color = [0 0 0];                            
er.LineStyle = 'none'; 
ylim([45 90]);
xticks = x;
xlabels = {'RED','GREEN','BLUE','>>x>>','<<x<<','One','Two','Three'};
xlabel('Test');
ylabel('Accuracy %');
line([0 11],[50 50],'color','k','linestyle','--','linewidth',1.5)
%legend('Stroop,n=18; Flanker,n=49; Number,n=57');
set(gca,'fontsize', 10,'xtick',xticks,'XTickLabel',xlabels,'box','off','FontName','Arial','tickDir','out','FontName','Arial')