addpath_recurse('functions_general');


n = 34; % At least 34 correct trials 
% Electrodes that didn't meet n=34 have been removed.  
for i_randsamp = 1:50 
    m_chan = 1;
    % sub1
    sel_chan_stroop = [122 123];
    sel_chan_flanker = [34];
    sel_chan_number = [105 122 123];

    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub1','result_theta','features_sub1.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub1_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub1_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub1_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub1_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub1_thetaMax_number_con{sel_chan(i)};
            tent2 = sub1_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub1_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub1_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub1_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub1_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub1_thetaMean_number_con{sel_chan(i)};
            tent2 = sub1_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end

    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    %% sub2
    sel_chan_stroop = [47 79 83 84 86 94 98 114 115 122 125 145 146 165 168];
    sel_chan_flanker = [33 79 114];
    sel_chan_number = [38 41 73 74 83:86 98:100 111 115 116 117 121 122 124 134 162:168 140];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub2','result_theta','features_sub2.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub2_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub2_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub2_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub2_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub2_thetaMax_number_con{sel_chan(i)};
            tent2 = sub2_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub2_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub2_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub2_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub2_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub2_thetaMean_number_con{sel_chan(i)};
            tent2 = sub2_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub3
    sel_chan_stroop = [34 122];
    sel_chan_flanker = [3 42 60 99 123 164 178 190];
    sel_chan_number = [3 17 188];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub3','result_theta','features_sub3.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub3_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub3_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub3_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub3_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub3_thetaMax_number_con{sel_chan(i)};
            tent2 = sub3_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub3_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub3_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub3_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub3_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub3_thetaMean_number_con{sel_chan(i)};
            tent2 = sub3_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;       
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub4
    sel_chan_stroop = [71 74];
    sel_chan_flanker = [102 144 148 153];
    sel_chan_number = [104 147 167 169];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub4','result_theta','features_sub4.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub4_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub4_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub4_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub4_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub4_thetaMax_number_con{sel_chan(i)};
            tent2 = sub4_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub4_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub4_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub4_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub4_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub4_thetaMean_number_con{sel_chan(i)};
            tent2 = sub4_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub5 
    sel_chan_stroop = [14 60];
    sel_chan_flanker = [53];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub5','result_theta','features_sub5.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub5_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub5_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub5_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub5_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub5_thetaMax_number_con{sel_chan(i)};
            tent2 = sub5_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub5_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub5_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub5_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub5_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub5_thetaMean_number_con{sel_chan(i)};
            tent2 = sub5_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub6
    sel_chan_stroop = [81];
    sel_chan_flanker = [];
    sel_chan_number = [54 55 95 106];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub6','result_theta','features_sub6.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub6_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub6_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub6_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub6_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub6_thetaMax_number_con{sel_chan(i)};
            tent2 = sub6_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub6_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub6_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub6_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub6_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub6_thetaMean_number_con{sel_chan(i)};
            tent2 = sub6_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub7 
    sel_chan_stroop = [62];
    sel_chan_flanker = [62];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub7','result_theta','features_sub7.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub7_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub7_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub7_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub7_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub7_thetaMax_number_con{sel_chan(i)};
            tent2 = sub7_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub7_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub7_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub7_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub7_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub7_thetaMean_number_con{sel_chan(i)};
            tent2 = sub7_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub8 
    sel_chan_stroop = [];
    sel_chan_flanker = [13];
    sel_chan_number = [48];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub8','result_theta','features_sub8.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub8_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub8_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub8_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub8_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub8_thetaMax_number_con{sel_chan(i)};
            tent2 = sub8_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub8_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub8_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub8_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub8_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub8_thetaMean_number_con{sel_chan(i)};
            tent2 = sub8_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;       
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan


%     % sub9
%     sel_chan_stroop = [33];
%     sel_chan_flanker = [];
%     sel_chan_number = [];
%     sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
% 
%     load(fullfile('data_recording','sub9','result_theta','features_sub9.mat'));
% 
%     if ~isempty(sel_chan)
%         for i = 1:length(sel_chan)
%             tent1 = conf_maxPower_stroop_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_stroop_in_sub9{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_flanker_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_flanker_in_sub9{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_number_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_number_in_sub9{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;
% 
%             tent1 = conf_meanPower_stroop_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_stroop_in_sub9{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_flanker_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_flanker_in_sub9{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_number_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_number_in_sub9{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;      
%         end
%     end
%     clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub10
    sel_chan_stroop = [7];
    sel_chan_flanker = [11 13 14 43 46 58 90];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub10','result_theta','features_sub10.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub10_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub10_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub10_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub10_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub10_thetaMax_number_con{sel_chan(i)};
            tent2 = sub10_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub10_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub10_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub10_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub10_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub10_thetaMean_number_con{sel_chan(i)};
            tent2 = sub10_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;       
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub11
    sel_chan_stroop = [];
    sel_chan_flanker = [12 32 76 77];
    sel_chan_number = [8 90];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub11','result_theta','features_sub11.mat'));    
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub11_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub11_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub11_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub11_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub11_thetaMax_number_con{sel_chan(i)};
            tent2 = sub11_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub11_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub11_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub11_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub11_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub11_thetaMean_number_con{sel_chan(i)};
            tent2 = sub11_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;       
        end
    end
    
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub12
    sel_chan_stroop = [6 83];
    sel_chan_flanker = [5 6 53 80];
    sel_chan_number = [23 53 54 111 124];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub12','result_theta','features_sub12.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub12_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub12_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub12_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub12_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub12_thetaMax_number_con{sel_chan(i)};
            tent2 = sub12_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub12_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub12_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub12_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub12_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub12_thetaMean_number_con{sel_chan(i)};
            tent2 = sub12_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;       
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub13
    sel_chan_stroop = [];
    sel_chan_flanker = [];
    sel_chan_number = [7 78];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub13','result_theta','features_sub13.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub13_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub13_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub13_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub13_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub13_thetaMax_number_con{sel_chan(i)};
            tent2 = sub13_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub13_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub13_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub13_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub13_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub13_thetaMean_number_con{sel_chan(i)};
            tent2 = sub13_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub14
    sel_chan_stroop = [77];
    sel_chan_flanker = [26];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub14','result_theta','features_sub14.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub14_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub14_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub14_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub14_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub14_thetaMax_number_con{sel_chan(i)};
            tent2 = sub14_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub14_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub14_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub14_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub14_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub14_thetaMean_number_con{sel_chan(i)};
            tent2 = sub14_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan


    % sub15
    sel_chan_stroop = [16];
    sel_chan_flanker = [];
    sel_chan_number = [76 78 93];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub15','result_theta','features_sub15.mat'));


    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub15_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub15_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub15_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub15_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub15_thetaMax_number_con{sel_chan(i)};
            tent2 = sub15_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub15_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub15_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub15_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub15_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub15_thetaMean_number_con{sel_chan(i)};
            tent2 = sub15_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub16
    sel_chan_stroop = [27 43];
    sel_chan_flanker = [27 32 92];
    sel_chan_number = [30 66];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub16','result_theta','features_sub16.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = sub16_thetaMax_stroop_con{sel_chan(i)};
            tent2 = sub16_thetaMax_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub16_thetaMax_flanker_con{sel_chan(i)};
            tent2 = sub16_thetaMax_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub16_thetaMax_number_con{sel_chan(i)};
            tent2 = sub16_thetaMax_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = sub16_thetaMean_stroop_con{sel_chan(i)};
            tent2 = sub16_thetaMean_stroop_in{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub16_thetaMean_flanker_con{sel_chan(i)};
            tent2 = sub16_thetaMean_flanker_in{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = sub16_thetaMean_number_con{sel_chan(i)};
            tent2 = sub16_thetaMean_number_in{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;        
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % SVM 
        n_sample = 34;
        % Stroop 
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 34;
        for i = 1:10 % 10-fold 
            X_train = [fea_stroop_con(train_ind(i,:),:);fea_stroop_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_stroop_con(test_ind(i,:),:);fea_stroop_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_stroop(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end

        % Flanker
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 52;
        for i = 1:10 % 10-fold 
            X_train = [fea_flanker_con(train_ind(i,:),:);fea_flanker_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_flanker_con(test_ind(i,:),:);fea_flanker_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_flanker(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end

        % Number
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 52;
        for i = 1:10 % 10-fold 
            X_train = [fea_number_con(train_ind(i,:),:);fea_number_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_number_con(test_ind(i,:),:);fea_number_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_number(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end
end    
%%
correct_stroop = correct_stroop(:); 
correct_flanker = correct_flanker(:); 
correct_number = correct_number(:); 
p_test(1) = permutationTest(correct_stroop(:),repmat(50,[numel(correct_stroop),1]),10000,'sidedness','larger');
p_test(2) = permutationTest(correct_flanker(:),repmat(50,[numel(correct_flanker),1]),10000,'sidedness','larger');
p_test(3) = permutationTest(correct_number(:),repmat(50,[numel(correct_number),1]),10000,'sidedness','larger');

% p_stroop_vs_flanker = permutationTest(correct_stroop(:),correct_flanker(:),10000);
% p_flanker_vs_number = permutationTest(correct_flanker(:),correct_number(:),10000);
% p_stroop_vs_number = permutationTest(correct_stroop(:),correct_number(:),10000);

% p_anova = randanova1([correct_stroop,correct_flanker,correct_number],[repmat(1,[1,10]),repmat(2,[1,10])...
%     repmat(3,[1,10])],10000);


%% Plot 
y = [mean(correct_stroop(:)),mean(correct_flanker(:)),mean(correct_number(:))];

sem = [std(correct_stroop(:))/sqrt(numel(correct_stroop)),std(correct_flanker(:))/sqrt(numel(correct_stroop)),std(correct_number(:))/sqrt(numel(correct_stroop))]; 
err = sem; 

x = [1, 1.5,2];
b = bar(x,y);
for i = 1:length(y)
    if i==1

            b = bar(x(i),y(i),'FaceColor',[0.968,0.501,0.547],'BarWidth', 0.4);
        hold on;
    elseif i==2

            b = bar(x(i),y(i),'FaceColor',[0.996,1,0.595],'BarWidth', 0.4);
        hold on;
    else

            b = bar(x(i),y(i),'FaceColor',[0.511 0.515 1],'BarWidth', 0.4);
        hold on;
    end
end

er = errorbar(x,y,err,err);    
er.Color = [0 0 0];                            
er.LineStyle = 'none'; 
er.CapSize = 5;

ylim([40 100])
xlim([0.7 2.3])
%xticks = [1 2 3];
%names = {'Stroop','Flanker','Number'};
hold on; 
set(gca,'XTickLabel',[]);set(gca,'XTick',[]);
line([0.5 3.5],[50 50],'color','k','linestyle','--','linewidth',1.5)
ylabel('Accuracy (%)');
%legend('train&test=Stroop','train&test=Flanker','train&test=Number');
set(gca,'fontsize', 8,'box','off','FontName','Arial','tickDir','out','FontName','Arial')
